"""
 Beispiel: Definition einer Klasse Auto
 Ableitung zweiter Instanzen.
 Nutzung einer Schleife mit Tastaturabfrage zur Steuerung der Autos
"""

from sum import *

# Definition eines Autos
class Auto:
  def __init__(self):
    self.hPosition=100
    self.vPosition=100
    self.stift=Buntstift(bildschirm)
  
  def bewegeBis(self,xneu,yneu):
    self.hPosition=xneu
    self.vPosition=yneu
  
  def gibFrei(self):
    self.stift.gibFrei()

  def setzeFarbe(self,farbe):
    self.stift.setzeFarbe(farbe)

  def bewegeUm(self,laenge):
    # mich selbst "wegradieren"
    self.stift.radiere()
    self.zeichne()
    # mich bewegen
    self.hPosition=self.hPosition+laenge   
    # mich zeichnen
    self.stift.normal()
    self.zeichne()
  
  def istAngekommen(self):
    return self.hPosition>400
  
  def zeichne(self):
    # Einen Wagen an der aktuellen x/y-Position zeichnen
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+4,self.vPosition)
    self.stift.runter()
    self.stift.bewegeBis(self.hPosition+20,self.vPosition)
    self.stift.bewegeBis(self.hPosition+24,self.vPosition+4)
    self.stift.bewegeBis(self.hPosition+28,self.vPosition+4)
    self.stift.bewegeBis(self.hPosition+28,self.vPosition+10)
    self.stift.bewegeBis(self.hPosition,self.vPosition+10)
    self.stift.bewegeBis(self.hPosition,self.vPosition+4)
    self.stift.bewegeBis(self.hPosition+4,self.vPosition)
    self.stift.hoch()

    self.stift.bewegeBis(self.hPosition+5,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+20,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.bewegeBis(self.hPosition+28,self.vPosition+5)
   
# Erzeuge Bildschirm und Maus
bildschirm=Bildschirm()
maus=Maus()
tastatur=Tastatur()
stift=Stift()
stift.bewegeBis(20,20)
stift.schreibe("Autorennen! Steuerung Auto1 mit <y>, Auto2 mit <->")

# Erzeuge einige Wagen.
auto1=Auto()
auto1.bewegeBis(100,100)
auto1.setzeFarbe(rot)
auto1.zeichne()

auto2=Auto()
auto2.bewegeBis(100,200)
auto2.setzeFarbe(gelb)
auto2.zeichne()

# Autos bewegen bis Sieger gefunden
sieger=0

while sieger==0:
  if tastatur.wurdeGedrueckt():
    z=tastatur.zeichen()
    if z=="y":
      auto1.bewegeUm(10)
      
    if z=="-":
      auto2.bewegeUm(10)

    if auto1.istAngekommen():
      stift.schreibe("Auto1 ist Sieger!")
      sieger=1

    if auto2.istAngekommen():
      stift.schreibe("Auto2 ist Sieger!")
      sieger=2

# Und Ende.
tastatur.gibFrei()
maus.gibFrei()
bildschirm.gibFrei()
