"""
 <Von Stiften und Musen>
 Eine neue Portierung fr Python, entstanden im Rahmen meiner Diplomarbeit.

 Klasse Tastatur von SuM

 erste Vers: 14.02.2002
 Version...: 02.03.2002
 Status....: OK.
 Autor.....: i.linkweiler@gmx.de
"""

import sumwrapper

class Tastatur:
  "Die Tastatur realisiert die Eingabe des verwendeten Computers."
  def __init__(self,kennt_bildschirm=None):
    "Aktiviert die Tastatureingabe."
    if kennt_bildschirm != None:
      self.bildschirm=kennt_bildschirm.bild
    else:
      self.bildschirm=sumwrapper.SCREEN

    #self.bildschirm=kennt_bildschirm.bild
    self.letzteeingabe=""
      
  def wurdeGedrueckt(self):
    "Liefert wahr, wenn eine Taste gedrckt wurde."
    self.letzteeingabe=self.bildschirm.eingaben()

    return self.letzteeingabe<>""
  	  
  def zeichen(self):
    "Liefert das gedrckte Zeichen."
    if self.letzteeingabe != "": c=self.letzteeingabe
    else: c=self.bildschirm.eingaben()
    self.letzteeingabe=""
    return c
      
  def gibFrei(self):
    "Die Tastatur steht nicht mehr zur Verfgung."
    pass

from bildschirm import *
def main():
    "Testprogramm."
    bild=Bildschirm()
    tast=Tastatur()

    while 1:
      if tast.wurdeGedrueckt():
        c=tast.zeichen()
        print "*"+c,
    maus.gibFrei()
    bild.gibFrei()
        
# call the "main" function if running this script
if __name__ == '__main__': main()